%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function [D_m,S_m,S]=cnst_law(F,xmu,xkp)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% determine stress, material and geometric tangent
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
C   = F'*F; 
I1  = trace(C);
Je  = sqrt(det(C)); 
Ci  = inv(C);
delta=[1 0 0; 0 1 0; 0 0 1];

Ci_m= [Ci(1,1); Ci(2,2); Ci(3,3); Ci(1,2); Ci(2,3); Ci(3,1)];  
unit= [1;1;1;0;0;0];

D1 = Ci_m * Ci_m';
D2 = unit * Ci_m';
D3 = Ci_m * unit';

D4(1,1)=Ci(1,1)^2;        D4(1,2)=Ci(1,2)^2;       D4(1,3)=Ci(1,3)^2;       
D4(1,4)=Ci(1,1)*Ci(1,2);  D4(1,5)=Ci(1,2)*Ci(1,3); D4(1,6)=Ci(1,3)*Ci(1,1);

D4(2,1)=Ci(2,1)^2;        D4(2,2)=Ci(2,2)^2;       D4(2,3)=Ci(2,3)^2;       
D4(2,4)=Ci(2,1)*Ci(2,2);  D4(2,5)=Ci(2,2)*Ci(2,3); D4(2,6)=Ci(2,3)*Ci(2,1);

D4(3,1)=Ci(3,1)^2;        D4(3,2)=Ci(3,2)^2;       D4(3,3)=Ci(3,3)^2;       
D4(3,4)=Ci(3,1)*Ci(3,2);  D4(3,5)=Ci(3,2)*Ci(3,3); D4(3,6)=Ci(3,3)*Ci(3,1);

D4(4,1)= Ci(1,1)*Ci(2,1); D4(4,2)=Ci(1,2)*Ci(2,2); D4(4,3)=Ci(1,3)*Ci(2,3); 
D4(4,4)=(Ci(1,1)*Ci(2,2)+Ci(1,2)*Ci(2,1))/2;
D4(4,5)=(Ci(1,2)*Ci(2,3)+Ci(1,3)*Ci(2,2))/2;
D4(4,6)=(Ci(1,3)*Ci(2,1)+Ci(1,1)*Ci(2,3))/2;

D4(5,1)= Ci(2,1)*Ci(3,1); D4(5,2)=Ci(2,2)*Ci(3,2); D4(5,3)=Ci(2,3)*Ci(3,3); 
D4(5,4)=(Ci(2,1)*Ci(3,2)+Ci(2,2)*Ci(3,1))/2;
D4(5,5)=(Ci(2,2)*Ci(3,3)+Ci(2,3)*Ci(3,2))/2;
D4(5,6)=(Ci(2,3)*Ci(3,1)+Ci(2,1)*Ci(3,3))/2;

D4(6,1)= Ci(3,1)*Ci(1,1); D4(6,2)=Ci(3,2)*Ci(1,2); D4(6,3)=Ci(3,3)*Ci(1,3); 
D4(6,4)=(Ci(3,1)*Ci(1,2)+Ci(3,2)*Ci(1,1))/2;
D4(6,5)=(Ci(3,2)*Ci(1,3)+Ci(3,3)*Ci(1,2))/2;
D4(6,6)=(Ci(3,3)*Ci(1,1)+Ci(3,1)*Ci(1,3))/2;

S   = xmu/Je^(-2.0/3.0) * (delta - I1/3.0 * Ci) ...
    + xkp*Je            * (Je-1.0) * Ci;   
S_m = [ S(1,1);  S(2,2);  S(3,3);  S(1,2);  S(2,3);  S(3,1)];
D_m = 2/3*xmu*Je^(-2/3)*(  I1/3.0*D1 -(D2+D3)+I1/2*(D4+D4')) ...
    +     xkp*Je*       ((2*Je-1)*D1 -(Je-1)*(D4+D4'));
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
