%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function [q0,edof,emat,bc,F_ext,mat,ndim,nel,node,ndof,nip,nlod] = ex_humer
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
tol  =  1e-8;

emod = 500;
nue  = 0.3;
rho0 = 1.00;
psi0 = 0.01;
expm = 3.0;
expn = 2.0;
dt   = 5.0;

mat = [emod,nue,rho0,psi0,expm,expn,dt];
%material parameters
%emod  nue  psi0*  rho0* expm  expn   dt
%500  0.20  0.01   1.20  3.00  2.00  2.0

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% generate node points q0 and connectivity edof
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
[q0,edof]=in_humer; 

[nel,sizen]  = size(edof);
[ndof,sizen] = size(q0);
 for ie=1:nel emat(ie) = 1; end;

 node = ndof/3;
 nip  = 1;
 ndim = 3;
 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% dirichlet and neumann boundary conditions
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%	
F_ext = zeros(ndof,1);
nlod  = 3;

ymin  = min(q0(2:3:ndof)) * 0.95;
ymax  = max(q0(2:3:ndof)) * 0.80; % shoulder side?
nb    = 1;

for nfix=2:3:ndof
  if(q0(nfix)>=ymax)     
    bc(nb,1) = nfix-1;
    bc(nb,2) = 0;
    nb = nb+1;
    bc(nb,1) = nfix;
    bc(nb,2) = 0;
    nb = nb+1;
    bc(nb,1) = nfix+1;
    bc(nb,2) = 0;
    nb = nb+1;
  end  
end

for nfor=2:3:ndof
  if(q0(nfor)<=ymin)
    bc(nb,1) = nfor;
    bc(nb,2) = 0.01*ymin; 
    nb = nb+1;
%%	F_ext(nfor,1)=-0.001;
  end    
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%	
%bc( 1,1)=  3*3-2;  bc( 1,2)=0;
%bc( 2,1)=  3*3-1;  bc( 2,2)=0;
%bc( 3,1)=  3*3-0;  bc( 3,2)=0;
%bc( 4,1)= 13*3-2;  bc( 4,2)=0;
%bc( 5,1)= 13*3-1;  bc( 5,2)=0;
%bc( 6,1)= 13*3-0;  bc( 6,2)=0;
%bc( 7,1)= 20*3-2;  bc( 7,2)=0;
%bc( 8,1)= 20*3-1;  bc( 8,2)=0;
%bc( 9,1)= 20*3-0;  bc( 9,2)=0;
%bc(10,1)= 55*3-2;  bc(10,2)=0;
%bc(11,1)= 55*3-1;  bc(11,2)=0;
%bc(12,1)= 55*3-0;  bc(12,2)=0;
%bc(13,1)=119*3-2;  bc(13,2)=0;
%bc(14,1)=119*3-1;  bc(14,2)=0;
%bc(15,1)=119*3-0;  bc(15,2)=0;
%bc(16,1)=145*3-2;  bc(16,2)=0;
%bc(17,1)=145*3-1;  bc(17,2)=0;
%bc(18,1)=145*3-0;  bc(18,2)=0;
%bc(19,1)=151*3-2;  bc(19,2)=0;
%bc(20,1)=151*3-1;  bc(20,2)=0;
%bc(21,1)=151*3-0;  bc(21,2)=0;
%bc(22,1)=167*3-2;  bc(22,2)=0;
%bc(23,1)=167*3-1;  bc(23,2)=0;
%bc(24,1)=167*3-0;  bc(24,2)=0;
%bc(25,1)=171*3-2;  bc(25,2)=0;
%bc(26,1)=171*3-1;  bc(26,2)=0;
%bc(27,1)=171*3-0;  bc(27,2)=0;
%bc(28,1)=184*3-2;  bc(28,2)=0;
%bc(29,1)=184*3-1;  bc(29,2)=0;
%bc(30,1)=184*3-0;  bc(30,2)=0;

%F0 = 0.02;

%F_ext(306*3-2,1) = 0.1881 * F0;
%F_ext(306*3-1,1) = 0.9407 * F0;
%F_ext(306*3-0,1) =-0.2822 * F0;

%F_ext(310*3-2,1) = 0.1826 * F0;
%F_ext(310*3-1,1) = 0.9129 * F0;
%F_ext(310*3-0,1) =-0.3651 * F0;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%	
% points to fix on Coarse Model:  
% 184,13,3,20,55,119,151,167,171,145        <-- or any 6 of these
%
% points to fix on Fine Model: 
% 180, 515, 20, 516, 55, 106, 167, 177, 514 <-- or any 6 of these
%
% points to apply force-- apply approx 200lbs at each node
%
% towards elbow    coarse: node #306   200lb * [0.1881  0.9407  -0.2822]
% towards shoulder coarse: node #310   200lb * [0.1826  0.9129  -0.3651]
%
% towards elbow    fine:   node #446   200lb * [0.1881  0.9407  -0.2822]
% towards shoulder fine:   node #453   200lb * [0.1826  0.9129  -0.3651]
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
